<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

// store
import { useUtilityStore } from '../../stores/utilitycost/utilitycost'
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

const utilityStore = useUtilityStore()
const UCDialog = ref(false)
const divItems = ref<HTMLElement | null>(null)

onMounted(() => {})

function onSubmit() {
  // Implement your form submission logic here
}

function formatDate(dateString: any) {
  const date = new Date(dateString)
  return date.toLocaleDateString('th-TH', {
    day: '2-digit',
    month: 'long',
    year: 'numeric'
  })
}
const headerBill = [
  {
    title: '#',
    key: 'id',
    value: 'id'
  },
  {
    title: 'ประเภท',
    key: 'type',
    value: 'type'
  },
  {
    title: 'ราคา',
    key: 'price',
    value: 'price'
  },
  {
    title: 'วันที่',
    key: 'date',
    value: 'date'
  },
  {
    title: 'ลบ'
  }
]
</script>

<template>
  <v-dialog v-model="utilityStore.newUcDialog" max-width="xl">
    <v-sheet border class="text-center mx-auto" style="height: 750px">
      <div class="d-flex align-center justify-end" style="padding-right: 5px; padding-top: 5px">
        <v-btn
          @click="utilityStore.clear"
          color="red-darken-4"
          icon="mdi-close-circle"
          size="small"
        ></v-btn>
      </div>
      <!-- title -->
      <div style="padding: 0px">
        <div class="align-center" style="padding-left: 20px">
          <h2 class="text-h4 font-weight-black">Utility Bill</h2>
          <p>บันทึกรายละเอียดค่าใช้จ่ายทั่วไป</p>
        </div>
        <v-divider class="border-opacity-50"></v-divider>
      </div>
      <!-- detail of user -->
      <div style="padding: 5px; height: 70px">
        <v-row class="d-flex align-center justify-end">
          <v-avatar rounded="0" style="padding-top: 10px" size="50">
            <v-img
              :src="
                'http://localhost:3000/images/users/' + utilityStore.initUtilityCost.user?.image
              "
            ></v-img>
          </v-avatar>
          <v-card-subtitle>
            ชื่อพนักงาน :
            {{ utilityStore.initUtilityCost.user?.name }}
          </v-card-subtitle>
        </v-row>
        <v-row class="d-flex align-center justify-end">
          <v-card-subtitle
            >วันที่ : {{ formatDate(utilityStore.initUtilityCost.creatDate) }}</v-card-subtitle
          >
        </v-row>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
      <!-- func AddItem -->
      <div style="padding: 5px; max-height: 500px">
        <v-row style="padding-left: 20px" no-gutters>
          <v-col cols="12" sm="6" md="4" style="padding-right: 5px">
            <v-text-field
              style="padding-top: 12px"
              v-model="utilityStore.type"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="string"
              clearable
              label="ประเภท"
              variant="outlined"
            >
            </v-text-field>
          </v-col>
          <v-col cols="12" sm="6" md="3" style="padding-right: 5px">
            <v-text-field
              style="padding-top: 12px"
              v-model="utilityStore.price"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="number"
              clearable
              label="ราคา"
              variant="outlined"
            >
            </v-text-field>
          </v-col>
          <v-col cols="12" sm="6" md="3" style="padding-right: 5px">
            <v-text-field
              style="padding-top: 12px"
              v-model="utilityStore.date"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="Date"
              clearable
              label="วันที่"
              variant="outlined"
            >
            </v-text-field>
          </v-col>

          <v-col cols="12" sm="6" md="2" style="padding-top: 20px; padding-right: 5px">
            <v-btn icon="mdi-language-markdown" size="small" @click="utilityStore.newItem"></v-btn>
          </v-col>
        </v-row>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
      <!-- Table Item -->
      <div style="padding: 5px" class="overflow-receipt-table">
        <v-card title="Invoice Items">
          <v-data-table-virtual
            :headers="headerBill"
            :items="utilityStore.ucDetails"
            height="300"
            fixed-header
            hide-default-footer
            disable-pagination
            class="flex-table"
            overflow-y="hidden"
          >
            <template v-slot:item="{ item }">
              <tr>
                <td>{{ item.id }}</td>
                <td>{{ item.type }}</td>
                <td>{{ item.price }}</td>
                <td>{{ formatDate(item.date) }}</td>
                <td>
                  <v-icon
                    icon="mdi-delete-circle"
                    size="large"
                    color="red"
                    @click="utilityStore.deleteItem(item)"
                  ></v-icon>
                </td>
              </tr>
            </template>
          </v-data-table-virtual>

          <div class="d-flex justify-end">
            <v-card height="45" md="6">
              <v-row>
                <v-col>
                  <v-card-sub-title
                    >จำนวนรวมทั้งหมด:
                    {{ utilityStore.initUtilityCost.totalItem }} รายการ</v-card-sub-title
                  >
                </v-col>
                <v-col>
                  <v-card-sub-title
                    >เป็นเงินทั้งหมด:
                    {{ utilityStore.initUtilityCost.totalPrice }}</v-card-sub-title
                  >
                </v-col>
                <v-col>
                  <div class="d-flex align-center justify-end">
                    <v-btn @click="utilityStore.saveBill">Save</v-btn>
                  </div>
                </v-col>
              </v-row>
            </v-card>
          </div>
        </v-card>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
    </v-sheet>
  </v-dialog>
</template>

<style scoped>
.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.overflow-receipt-table {
  overflow-y: auto;
}

.overflow-receipt-table::-webkit-scrollbar {
  display: none;
}
</style>
